;#SECTION "MAIN", CODE

chNewLine equ	0D6h
;#SECTION "Menu", CODE

Menu:
	push	hl
	B_CALL	_ClrScrnFull
	ld	hl, 0
	ld	(curRow), hl
	pop	hl
	call	PutS
	push	hl
.keyLoop:
	in	a, (4)
	and	00001000b
	jq	z, Quit
	ei
	halt
	B_CALL	_GetCSC
	or	a
	jq	z, .keyLoop
	pop	hl
	push	hl
	ld	b, a
	ld	a, (hl)
	or	a
; This is bad
; CALL Z,panic
.mkla:
	ld	a, (hl)
	or	a
	jq	z, .keyLoop
	cp	b
	jq	z, .mklb
	inc	hl
	inc	hl
	inc	hl
	jq	.mkla

.mklb:
	pop	de
	inc	hl
	call	ldHLindirect
	push	af
	ld	a, (hl)
	or	a
	jq	z, .mklc
	pop	af
	jp	(hl)

.mklc:
	pop	af
	inc	hl
	jq	Menu

;#SECTION "PutS", CODE

PutS:
	ld	a, (hl)
	inc	hl
	or	a
	ret	z
	cp	chNewLine
	jq	z, @F
	cp	chInverse
	jq	z, .inv
	cp	chNormal
	jq	z, .norm
	B_CALL	_PutC
	jq	PutS

@:
	ld	a, (curRow)
	inc	a
	ld	(curRow), a
	xor	a
	ld	(curCol), a
	jq	PutS

.inv:
	set	textInverse, (iy + textFlags)
	jq	PutS

.norm:
	res	textInverse, (iy + textFlags)
	jq	PutS

;#SECTION "ldHLind", CODE

ldHLindirect:
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	ret

;#SECTION "cphlde", CODE

cphlde:
	or	a
	sbc	hl, de
	add	hl, de
	ret

