;#SECTION "MAIN", CODE

; Returns:
; -HL: Num
; hl: scan tabe
; c: chars
GetNum:
	res	shiftAlpha, (iy + shiftFlags)
	res	shift2nd, (iy + shiftFlags)
	B_CALL	_CursorOn
	ld	de, OP1
	ld	c, 0
.nameLoop:
	push	bc
	push	de
	ei
	halt
	B_CALL	_GetCSC
	pop	de
	pop	bc
	or	a
	jq	z, .nameLoop
	cp	skClear
	jq	z, .clear
	cp	skDel
	jq	z, .back
	cp	skLeft
	jq	z, .back
	cp	skEnter
	jq	z, .done
	ld	hl, .NumTable
	ld	b, .nums
; LD   B,11
.scan:
	cp	(hl)
	inc	hl
	jq	z, .found
	inc	hl
	djnz	.scan
	jq	.nameLoop

.found:
	ld	a, c
	cp	maxChars
	jq	z, .nameLoop
	ld	a, (hl)
	ld	(de), a
	inc	de
	inc	c
	ld	a, (hl)
	B_CALL	_PutC
	jq	.nameLoop

.back:
.clear:
	ld	a, c
	or	a
	jq	z, .nameLoop
	push	de
	push	bc
	B_CALL	_CursorOff
	pop	bc
	pop	de
	ld	a, c
	dec	a
	ld	c, a
	ld	a, (curCol)
	dec	a
	ld	(curCol), a
	push	af
	ld	a, 32
	B_CALL	_PutC
	pop	af
	ld	(curCol), a
	dec	de
	xor	a
	ld	(de), a
	push	bc
	push	de
	B_CALL	_CursorOn
	pop	de
	pop	bc
	jq	.nameLoop

.done:
	xor	a
	cp	c
	jq	z, .nameLoop
	ld	(de), a
	inc	de
	ld	(de), a
	dec	de
	B_CALL	_CursorOff
	ret

;#SECTION "KeyTable", DATA

.NumTable:
; .nums = (.NumTableEnd-.NumTable)/2
.nums equ	11
	db	sk0, '0'
	db	sk1, '1'
	db	sk2, '2'
	db	sk3, '3'
	db	sk4, '4'
	db	sk5, '5'
	db	sk6, '6'
	db	sk7, '7'
	db	sk8, '8'
	db	sk9, '9'
	db	skDecPnt, '.'
.NumTableEnd:
